// 그리디
// 어디에 설치하냐는 중요하지 않다.
// 그걸 풀려고 하면 망한다.
// 중요한건 기지국의 갯수다 갯수
// 문제 자체가 함정이 있다.
// 모든 경우의 수를 구하거나, 새로 배열을 만들어서 하면
// 시간초과와 코드가 굉장히 어려워진다.
// 풀이는 그리디 적으로 생각해야한다.
// 매 순간 최적의 결과를 선택해야한다.
// 최적의 선택은 무엇인가?
// 가장 넓은 범위에 짓는 것이다.
// 이미 기지국이 설치되어 있는 것은 아무런 중요하지 않다.
// 그저 커버가 안되어 있는 곳이 보이면
// 그곳을 커버할 수 있는 가장 최적의 지역에 짓는다고 가정하는 것이다.
// 그렇게 기지국 수를 체크하고
// 그 다음에 위치를 이동햐야한다.
// 최대한 기지국이 커버하는 지역까지 간뒤
// 거기서 이 지역에 기지국이 있는지 확인한다.
// 기지국이 설치되어 있는지 판단하는 로직이 중요한다,
// 그것은 기지국을 얼마나 지나왔는지 계산하는 것이다.
// 현재 위치에서 이미 설치된 기지국의 범위에 들어와 있는지를 계산해야 한다.
// 그것은 기지국 순서를 주요 포인트로 잡아서 현재 나의 위치보다
// 기지국 순서상 첫번쨰가 나의 위치보다 더 아래에 있으면, 해당 기지국의 범위를
// 정한다. 이때는 반경만 알고 오른쪽으로 가면 되므로
// 그 위치만 계산하고, 기지국의 순서는 두번쨰로 세팅해놓는다.
// 그 다음 루프에서도 기지국의 범위가 있다면, 또 체크될 것이다.
// 따라서, 먼저 내 위치가 기지국 범위에 있는지를 보고
// 그다음 else 문은 확실히 기지국이 설치가 안된 지역일 것이다.

function solution(n, stations, w) {
  let pos = 1;
  let cnt = 0;
  let idx = 0;

  while (pos <= n) {
    if (idx < stations.length && pos >= stations[idx] - w) {
      pos = stations[idx] + w + 1;
      ++idx;
    } else {
      pos += 2 * w + 1;
      ++cnt;
    }
  }

  return cnt;
}
